package com.logicbig.example;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.LockModeType;
import javax.persistence.Persistence;

public class ForceIncrementExample {
    private static EntityManagerFactory entityManagerFactory =
            Persistence.createEntityManagerFactory("example-unit");

    public static void main(String[] args) {
        try {
            persistArticle();
            updateArticle();
        } finally {
            entityManagerFactory.close();
        }
    }

    private static void updateArticle() {
        System.out.println("-- updating article --");
        EntityManager em = entityManagerFactory.createEntityManager();
        Article article = em.find(Article.class, 1L);
        em.getTransaction().begin();
        em.lock(article, LockModeType.OPTIMISTIC_FORCE_INCREMENT);
        if (article.getContent().length() < 5) {
            article.setContent("updated content");
        }
        em.getTransaction().commit();
        em.close();
        System.out.println("Article updated : " + article);
    }

    public static void persistArticle() {
        System.out.println("-- persisting article --");
        Article article = new Article("test article");
        EntityManager em = entityManagerFactory.createEntityManager();
        em.getTransaction().begin();
        em.persist(article);
        em.getTransaction().commit();
        em.close();
        System.out.println("Article persisted: " + article);
    }
}